// Euphorica's Regular Attack.
freeslot("MT_EUPHTELEPORT")
attackDefs["teleport"] = {
		name = "Teleport",				
		type = ATK_STRIKE,	    		
		power = 30,						
		accuracy = 100,					
		costtype = CST_HP,				
		cost = 0,						
		critical = 10,
		anim_norepel = true,
		physical = true,
		desc = "Light strike damage to \none enemy.",
		target = TGT_ENEMY,				

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			
			if timer == 1
				local an = mo.angle
				local cx = mo.x - 200*cos(an)
				local cy = mo.y - 200*sin(an)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z+mo.height, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
			end
			
			if timer < TICRATE/4
				ANIM_set(mo, mo.anim_run)
				P_InstaThrust(mo, mo.angle, 5*FRACUNIT)
			elseif timer < TICRATE
				ANIM_set(mo, mo.anim_atk)
				P_InstaThrust(mo, mo.angle, 1*FRACUNIT)
			end
			
			if timer == TICRATE/4
				playSound(mo.battlen, sfx_jump)
				P_SetObjectMomZ(mo, 10*FRACUNIT)
			elseif timer == TICRATE
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				P_TeleportMove(mo, target.x - 30*cos(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),
				                   target.y - 30*sin(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),
								   target.z)
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				playSound(mo.battlen, sfx_etelep)
				ANIM_set(mo, mo.anim_run)
				P_InstaThrust(mo, mo.angle, 30*FRACUNIT)
				for i = 1, 20
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_SMOKE)
					dust.momx = P_RandomRange(-20, 20)*FRACUNIT
					dust.momy = P_RandomRange(-20, 20)*FRACUNIT
					dust.momz = P_RandomRange(-20, 20)*FRACUNIT
				end
				playSound(mo.battlen, sfx_euphbs)
				if not target.plyr then createSplat(mo) end
				if not target.plyr then createSplat(mo) end
				localquake(mo.battlen, FRACUNIT*10, 10)
				damageObject(target)
			end

			if timer == 2*TICRATE
				return true
			end
		end,				

		critanim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			
			if timer == 1
				local an = mo.angle
				local cx = mo.x - 200*cos(an)
				local cy = mo.y - 200*sin(an)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z+mo.height, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
			end
			
			if timer < TICRATE/4
				ANIM_set(mo, mo.anim_run)
				P_InstaThrust(mo, mo.angle, 5*FRACUNIT)
			elseif timer < TICRATE
				ANIM_set(mo, mo.anim_atk)
				P_InstaThrust(mo, mo.angle, 1*FRACUNIT)
			elseif timer > TICRATE
				mo.momz = 0
			end
			
			if timer == TICRATE/4
				playSound(mo.battlen, sfx_jump)
				P_SetObjectMomZ(mo, 10*FRACUNIT)
			elseif timer == TICRATE
				local an = target.angle + 45*ANG1
				local cx = target.x + 250*cos(an)
				local cy = target.y + 250*sin(an)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				P_TeleportMove(mo, target.x + 200*FRACUNIT,
				                   target.y,
								   target.z + 79*FRACUNIT)
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				playSound(mo.battlen, sfx_etelep)
			elseif timer == TICRATE+5
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				P_TeleportMove(mo, target.x,
				                   target.y + 180*FRACUNIT,
								   target.z + 60*FRACUNIT)
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				playSound(mo.battlen, sfx_etelep)
			elseif timer == TICRATE+10
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				P_TeleportMove(mo, target.x,
				                   target.y,
								   target.z + 150*FRACUNIT)
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				playSound(mo.battlen, sfx_etelep)
			elseif timer == TICRATE+15
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				P_TeleportMove(mo, target.x + 130*FRACUNIT,
				                   target.y,
								   target.z + 40*FRACUNIT)
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				playSound(mo.battlen, sfx_etelep)
			elseif timer == TICRATE+20
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				P_TeleportMove(mo, target.x,
				                   target.y,
								   target.z + 40*FRACUNIT)
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				playSound(mo.battlen, sfx_etelep)
			elseif timer == TICRATE+25
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				P_TeleportMove(mo, target.x,
				                   target.y,
								   target.z)
				P_SpawnMobj(mo.x, mo.y, mo.z, MT_EUPHTELEPORT)
				Euphorica.spawnsparks(mo, 20)
				playSound(mo.battlen, sfx_etelep)
				ANIM_set(mo, mo.anim_run)
				P_InstaThrust(mo, mo.angle, 30*FRACUNIT)
				for i = 1, 20
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_SPINDUST)
					dust.momx = P_RandomRange(0, 20)*FRACUNIT
					dust.momy = P_RandomRange(0, 20)*FRACUNIT
					dust.momz = P_RandomRange(0, 20)*FRACUNIT
				end
				Euphorica.spawnsparks(target, 10)
				playSound(mo.battlen, sfx_euphbs)
				if not target.plyr then createSplat(mo) end
				if not target.plyr then createSplat(mo) end
				localquake(mo.battlen, 15*FRACUNIT, 10)
				damageObject(target)
			end

			if timer == (2*TICRATE)+(TICRATE/2)
				return true
			end
		end,
}

// Euphorica's progressive PSY move.
attackDefs["psyblast"] = {
    name = "Psy-Blast",                
    type = ATK_PSY,                       
    power = 50,                        
    accuracy = 97,                    
    costtype = CST_SP,        
    cost = 8,                        
    critical = 5,                    
    desc = "Light Psy Damage to \none enemy. Low \ncritical hit chance.",
    target = TGT_ENEMY,  				

	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
			
		if timer == 2
			playSound(mo.battlen, sfx_hamas1)
			local shot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
			shot.frame = FF_FULLBRIGHT|A
			shot.color = SKINCOLOR_PURPLE
			shot.tracer = target
			shot.tics = 10*TICRATE
			shot.fuse = 10*TICRATE
			mo.psyblast = shot
		end
		
		if mo.psyblast
			local r = mo.psyblast

			if r.valid
				local dist = P_AproxDistance(P_AproxDistance(target.x - r.x, target.y - r.y), target.z - r.z)
				r.momx = FixedMul(FixedDiv(target.x - r.x, dist), 32<<FRACBITS)
				r.momy = FixedMul(FixedDiv(target.y - r.y, dist), 32<<FRACBITS)
				r.momz = FixedMul(FixedDiv(target.z - r.z, dist), 32<<FRACBITS)
			end
		end
		
		if timer == TICRATE
			playSound(mo.battlen, sfx_rail1)
			if not target.plyr then createSplat(mo) end
			localquake(mo.battlen, 10*FRACUNIT, 10)
			damageObject(target)
			local r = mo.psyblast
			playSound(mo.battlen, sfx_s3k74)
			for i = 1, 5
				local psiocolors = {SKINCOLOR_TEAL, SKINCOLOR_YELLOW, SKINCOLOR_PINK, SKINCOLOR_BLACK, SKINCOLOR_WHITE}
				local ol = P_SpawnMobj(r.x + P_RandomRange(-250, 250)*FRACUNIT, r.y + P_RandomRange(-250, 250)*FRACUNIT, r.z + P_RandomRange(0, 250)*FRACUNIT, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20
			end
			P_RemoveMobj(r)
		end

		if timer == 2*TICRATE
			return true
		end
	end,
}

attackDefs["psystrike"] = {
    name = "Psy-Strike",                
    type = ATK_PSY,                       
    power = 130,                        
    accuracy = 96,                    
    costtype = CST_SP,        
    cost = 16,                        
    critical = 10,                    
    desc = "Medium Psy Damage to \none enemy. Medium \ncritical hit chance.",
    target = TGT_ENEMY,    		

	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		// Sparkles around the target
		if timer == 2
			playSound(mo.battlen, sfx_euphls)
		elseif timer < TICRATE and (timer%5 == 0)
			local s = P_SpawnMobj(target.x + P_RandomRange(-128, 128)<<FRACBITS, target.y + P_RandomRange(-128, 128)<<FRACBITS, target.z + P_RandomRange(0, 100)<<FRACBITS, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = $*2 + P_RandomRange(0, 65535)
			playSound(mo.battlen, sfx_hamas1)
		end
		
		// Adjust the Camera.
		if timer == TICRATE
			local an = target.angle + 45*ANG1
			local cx = target.x + 384*cos(an)
			local cy = target.y + 384*sin(an)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
			
			mo.psystrikemo = {}
		end
		
		// PsyStrike Mobjs
		if timer > TICRATE and timer < 4*TICRATE
			if (leveltime%10 == 0)
				local thing = P_SpawnMobj(target.x + (P_RandomRange(-300, 300)*target.scale), target.y + (P_RandomRange(-300, 300)*target.scale), target.z + (P_RandomRange(0, 300)*target.scale), MT_DUMMY)
				local colours = {SKINCOLOR_RED, SKINCOLOR_GREEN, SKINCOLOR_VIOLET, SKINCOLOR_WHITE, SKINCOLOR_ORANGE}
				local c = P_RandomRange(1, #colours)
				thing.sprite = SPR_THOK
				thing.color = colours[c]
				thing.scale = 2*target.scale
				thing.tics = 10*TICRATE
				thing.fuse = 10*TICRATE
				mo.psystrikemo[#mo.psystrikemo+1] = thing
			end
		end
		
		local i
		if mo.psystrikemo
			i = #mo.psystrikemo
			while i
				local h = mo.psystrikemo[i]
				if not h or not h.valid
					table.remove(mo.psystrikemo, i)
					i = $-1
					continue
				end
				local dist = P_AproxDistance(P_AproxDistance(target.x - h.x, target.y - h.y), target.z - h.z)
				h.momx = FixedMul(FixedDiv(target.x - h.x, dist), 32<<FRACBITS)
				h.momy = FixedMul(FixedDiv(target.y - h.y, dist), 32<<FRACBITS)
				h.momz = FixedMul(FixedDiv(target.z - h.z, dist), 32<<FRACBITS)
				if dist < 5*FRACUNIT
					local psiocolors = {SKINCOLOR_TEAL, SKINCOLOR_YELLOW, SKINCOLOR_PINK, SKINCOLOR_BLACK, SKINCOLOR_WHITE}
					local ol = P_SpawnMobj(h.x + P_RandomRange(-100, 100)*FRACUNIT, h.y + P_RandomRange(-100, 100)*FRACUNIT, h.z + P_RandomRange(0, 100)*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					P_SetObjectMomZ(target, 4*FRACUNIT)
					playSound(mo.battlen, sfx_bufu2)
				end
				i = $-1
			end
		end
		
		// Damage the mobj
		if timer == 3*TICRATE
			if not target.plyr then createSplat(mo) end
			localquake(mo.battlen, 20*FRACUNIT, 10)
			damageObject(target)
		end

		if timer == (3*TICRATE)+(TICRATE/2)
			for k,v in ipairs(mo.psystrikemo)
				P_RemoveMobj(v)
			end
			return true
		end
	end,
}

attackDefs["psysplosion"] = {
    name = "Psy-Splosion",                
    type = ATK_PSY,                       
    power = 320,                        
    accuracy = 95,                    
    costtype = CST_SP,        
    cost = 32,                        
    critical = 15,                    
    desc = "Heavy Psy Damage to \none enemy. Medium \ncritical hit chance.",
    target = TGT_ENEMY,

	anim_norepel = true,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			local an = mo.angle + ANGLE_180
			local cx = mo.x - (200-timer)*cos(an)
			local cy = mo.y - (200-timer)*sin(an)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(target.x, target.y, cx, cy))
		end
		
		if timer < 2*TICRATE
			ANIM_set(mo, mo.anim_special1)
			local gather = P_SpawnMobj(mo.x+P_RandomRange(-200, 200)*FRACUNIT, mo.y+P_RandomRange(-200, 200)*FRACUNIT, mo.z+P_RandomRange(0, 250)*FRACUNIT, MT_PSYXPLDGATHER)
			gather.tracer = mo
			local colours = {SKINCOLOR_RED, SKINCOLOR_GREEN, SKINCOLOR_VIOLET, SKINCOLOR_WHITE, SKINCOLOR_ORANGE}
			local c = P_RandomRange(1, #colours)
			gather.color = colours[c]
			gather.destscale = FRACUNIT/8
		elseif timer == 2*TICRATE
			ANIM_set(mo, mo.anim_stand)
			local an = mo.angle
			local cx = mo.x - 200*cos(an)
			local cy = mo.y - 200*sin(an)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
			local sphere = P_SpawnMobj(mo.x + 20*cos(mo.angle), mo.y + 20*sin(mo.angle), mo.z, MT_DUMMY)
			sphere.sprite = SPR_THOK
			sphere.color = SKINCOLOR_PURPLE
			sphere.frame = FF_FULLBRIGHT|A
			sphere.scale = FRACUNIT/2
			sphere.tics = 10*TICRATE
			sphere.fuse = 10*TICRATE
			mo.psysplosion = sphere
		end
		
		if mo.psysplosion
			local s = mo.psysplosion
			local dist = P_AproxDistance(P_AproxDistance(target.x - s.x, target.y - s.y), target.z - s.z)
			s.momx = (FixedMul(FixedDiv(target.x - s.x, dist), 32<<FRACBITS))/2
			s.momy = (FixedMul(FixedDiv(target.y - s.y, dist), 32<<FRACBITS))/2
			s.momz = (FixedMul(FixedDiv(target.z - s.z, dist), 32<<FRACBITS))/2
			
			local particle = P_SpawnMobj(s.x + P_RandomRange(-200, 200)*FRACUNIT,
										 s.y + P_RandomRange(-200, 200)*FRACUNIT,
										 s.z + P_RandomRange(0, 200)*FRACUNIT,
										 MT_SUPERSPARK)
			particle.color = SKINCOLOR_PINK
			particle.colorized = true
			if (timer%10==0)
				for i = 1, 3
					local psiocolors = {SKINCOLOR_TEAL, SKINCOLOR_YELLOW, SKINCOLOR_PINK, SKINCOLOR_BLACK, SKINCOLOR_WHITE}
					local ol = P_SpawnMobj(s.x + P_RandomRange(-250, 250)*FRACUNIT, s.y + P_RandomRange(-250, 250)*FRACUNIT, s.z + P_RandomRange(0, 250)*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20
				end
			end

			if timer == 3*TICRATE and s.valid
				local an = target.angle + 45*ANG1
				local cx = target.x + 384*cos(an)
				local cy = target.y + 384*sin(an)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				
				s.destscale = 10*FRACUNIT
				S_StartSound(s, sfx_zoom)
			end
			
			if timer == 4*TICRATE and s.valid
				if not target.plyr then createSplat(mo) end
				DoExplosion(s)
				s.fuse = 2
				mo.psysplosion = nil
			end
		end
		
		if timer == 4*TICRATE
			damageObject(target)
		end
		
		if timer == 5*TICRATE
			return true
		end
	end,
}

// Psy-Struction
attackDefs["psystruction"] = {
	name = "Psy-Struction",				
	type = ATK_PSY,
	power = 400,
	accuracy = 90,
	costtype = CST_SP,
	cost = 53,
	critical = 5,
	technical = COND_BURN,
	desc = "Heavy Psy Damage to \nall enemies.",
	target = TGT_ALLENEMIES,				

	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $+ hittargets[i].x/FRACUNIT
			avgy = $+ hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		local targtomo = R_PointToAngle2(avgx, avgy, mo.x, mo.y)
		local mototarg = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
		
		// Ha!
		if timer == 1
			local an = mo.angle + ANGLE_180
			local cx = mo.x - (200-timer)*cos(an)
			local cy = mo.y - (200-timer)*sin(an)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, targtomo)
		elseif timer == 20
			playSound(mo.battlen, sfx_hamas1)
			ANIM_set(mo, mo.anim_special1)
		elseif timer == 30
			ANIM_set(mo, mo.anim_stand)
		elseif timer == 50
			local an = mototarg
			local cx = avgx + 400*cos(an)
			local cy = avgy + 400*sin(an)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z + 50*FRACUNIT, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, avgx, avgy))
		end
		
		if timer == 60
			mo.psystrctmo = {}
		end
		
		// Laser
		if timer > 60 and timer < 150
			if (timer%5 == 0) then playSound(mo.battlen, sfx_hamas1) end
			local an = leveltime*ANG1*2
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			m.state = S_MEGITHOK
			m.colorized = true
			m.color = SKINCOLOR_PINK
			m.scale = FRACUNIT*3/2
			m.fuse = TICRATE
			mo.psystrctmo[#mo.psystrctmo+1] = m
			m.extravalue = an + i*(360/8)*ANG1
			m.extravalue2 = 128 + (timer-130)*8
			Euphorica.dispersemo(m, MT_SUPERSPARK, SKINCOLOR_PINK)
			m.momz = 56*FRACUNIT
			localquake(mo.battlen, 20*FRACUNIT, 10)
		end
	
		// Spin some Psy-Struction mobjs
		local i
		if mo.psystrctmo
			i = #mo.psystrctmo
			while i
				local h = mo.psystrctmo[i]
				if not h or not h.valid
					table.remove(mo.psystrctmo, i)
					i = $-1
					continue
				end
				P_TeleportMove(h, avgx + h.extravalue2*cos(h.extravalue), avgy + h.extravalue2*sin(h.extravalue), h.z)
				h.extravalue = $+ ANG1*64
				h.extravalue2 = $+8
				i = $-1
			end
		end
		
		if timer == 160
			for k,v in ipairs(hittargets)
				damageObject(v)
			end
		elseif timer == 175
			return true
		end
	end,
}

-- Unused... Unless...
attackDefs["salvation"] = {
	name = "Salvation",
	type = ATK_HEAL,
	costtype = CST_SP,
	cost = 45,
	power = 999999,
	desc = "Full HP recover to all allies, \nand heals status effects.",
	target = TGT_ALLALLIES,
	nocast =	function(targets, n)	-- we can't cast this skill if this function returns true
		local noheal = 0
		for i = 1, #targets
			if targets[i].hp >= targets[i].maxhp and targets[i].status_condition >= COND_BURN and targets[i].status_condition < COND_HYPER
				noheal = $+1
			end
		end
		if noheal >= #targets
			BTL_logMessage(targets[1].battlen, "No further effects.")
			return true
		end
	end,
	anim = function(mo, targets, hittargets, timer)
		for e = 1, #targets
			local time = timer - 10*(e-1)
			local target = targets[e]

			if time == 20
				target.heal_rings = {}
			elseif time >= 21
			and time < 70
				if time < 40
					for i = 1,2
						local x, y, z = mo.x + P_RandomRange(-400,400)<<FRACBITS, mo.y + P_RandomRange(-400,400)<<FRACBITS, mo.z + P_RandomRange(0, 400)<<FRACBITS
						local r = P_SpawnMobj(x, y, z, MT_DUMMY)
						r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						r.state = S_RING
						r.target = target
						r.tracer = target

						local dist = P_AproxDistance(P_AproxDistance(target.x - r.x, target.y - r.y), target.z - r.z)
						r.momx = FixedMul(FixedDiv(target.x - r.x, dist), 32<<FRACBITS)
						r.momy = FixedMul(FixedDiv(target.y - r.y, dist), 32<<FRACBITS)
						r.momz = FixedMul(FixedDiv(target.z - r.z, dist), 32<<FRACBITS)
						r.fuse = 20

						--A_HomingChase(r, FRACUNIT*32)
						r.scale = 1
						r.destscale = FRACUNIT
						r.scalespeed = FRACUNIT/4
						target.heal_rings[#target.heal_rings+1] = r
					end
				end
				for i = 1, #target.heal_rings
					local r = target.heal_rings[i]
					if not r or not r.valid continue end
					if R_PointToDist2(target.x, target.y, r.x, r.y) < 40<<FRACBITS
					and abs(r.z - mo.z) < 40<<FRACBITS
						playSound(mo.battlen, sfx_itemup)
						r.state = S_SPRK1
						table.remove(target.heal_rings, i)
						i = $-1
					end
				end

			elseif time == 70
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = target.maxhp
				playSound(mo.battlen, sfx_heal4)
				damageObject(target, -heals)
				if target.status_condition and target.status_condition < COND_HYPER
					cureStatus(target)
				end
			end
		end

		if timer == 110 + (#targets-1)*10
			return true
		end
	end,
}

// Auto Mamaka
attackDefs["auto-mamaka"] = {
	name = "Auto-Mamaka",
	type = ATK_PASSIVE,
	target = TGT_ALLALLIES,
	desc = "Party starts battles \nwith a Magic Attack buff.",
	passive = PSV_STARTBATTLE,
	anim = function(mo, targets, hittargets, timer)
			for i = 1, #mo.allies do
				local target = mo.allies[i]
				buffStat(target, "mag")
			end
		end,
}