if not srb2p return end

freeslot(
// PlayerSprites
"SPR2_DOWN", "SPR2_SUPT", "SPR2_CSMN",

// Sounds
"sfx_etelep", "sfx_euphls", "sfx_euphbs")

// Define our Euph Stats
charStats["euphorica"] = {
		-- GENERAL
		name = "Euphorica",		-- This is only for bots / enemies
		basehp = 50,			-- base HP for level 1 (Cannot be <= 0)
		basesp = 40,			-- base SP for level 1 (Can be 0, but not < 0!)
		persona = "euphorica",	-- Persona to use
		melee_natk = "teleport",	-- normal melee attack

		-- Normal attack attributes
		-- Scales with character level
		atk = 25,	-- power (generally < 50)
		acc = 98,	-- accuracy (%)
		crit = 10,	-- crit rate (%)

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
		-- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},				-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_WAIT"},				-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_STND"},				-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_SPNG"},				-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_RUN_"},-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},		-- attacking
		anim_aoa_end =		{SPR_PLAY, D, C, B, A, 2, "SPR2_ROLL"},		-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},				-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_DOWN"},				-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_DOWN"},				-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},				-- dies
		anim_revive =		{SPR_PLAY, A, 1, "SPR2_SPNG"},				-- gets revived
		anim_evoker =       {SPR_PLAY, A, 1, "SPR2_CSMN"},				-- using evoker.
	
		anim_stand_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},				-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_run_super = 	{SPR_PLAY, A, 2, "SPR2_SPNG"},				-- run

		-- anim_special1 through anim_special32 may also be used for various purposes (ie: attack animations)
		anim_special1 =		{SPR_PLAY, A, TICRATE, "SPR2_FIRE"},
		anim_special2 =		{SPR_PLAY, A, TICRATE, "SPR2_SUPT"},
		
		supercolor_start = SKINCOLOR_SUPERGOLD1,

		-- VOICES
		-- Silent character go brrr

		vfx_summon = {},	-- Summoning Persona to use a Skill
        vfx_skill = {},		-- Used a Skill
        vfx_item = {},		-- Used an item
        vfx_hurt = {},		-- Sustained damage
        vfx_hurtx = {},		-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {},		-- Death
        vfx_heal = {},		-- Healed by teammate
        vfx_healself = {},	-- Healed self
        vfx_kill = {},		-- Killed an enemy
        vfx_1more = {},		-- Performed 1more
        vfx_crit = {},		-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {},	-- Ask to All-Out Attack
        vfx_aoado = {},		-- Performing All-Out Attack
        vfx_aoarelent = {},	-- Relenting from All-Out Attack
        vfx_miss = {},		-- Missed attack
        vfx_dodge = {},		-- Dodged enemy attack
        vfx_win = {},		-- Battle won
        vfx_levelup = {},	-- Level Up!

		-- HUD DEFINTIIONS
		icon = "ICO_EUPH",				-- head icon for character select
		hudbust = "EUPHBAR",			-- patch to draw on the stat hud
		hudaoa = "EUPHAOA",				-- patch for all out attack hud
		aoa_quote = "...! ...! .....!",	-- all out attack quote.
		hudcutin = "EUPH_A",			-- cut in frames prefix

		-- Tip to display on the character select.
		-- Give insight on their skill type and their strengths/weaknesses in battle!
		tip = "Learns Psy, Buffing and Healing skills. \nThey're more of a support, but can sometimes\n have a better time attacking due to\n their Psy Moves being able to crit.",
}

charStats["legacy"] = {
		-- GENERAL
		name = "Euphorica?",		-- This is only for bots / enemies
		basehp = 45,			-- base HP for level 1 (Cannot be <= 0)
		basesp = 56,			-- base SP for level 1 (Can be 0, but not < 0!)
		persona = "euphorica_legacy",	-- Persona to use
		melee_natk = "teleport",	-- normal melee attack

		-- Normal attack attributes
		-- Scales with character level
		atk = 25,	-- power (generally < 50)
		acc = 95,	-- accuracy (%)
		crit = 10,	-- crit rate (%)

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
		-- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},				-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_WAIT"},				-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_STND"},				-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_SPNG"},				-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},		-- attacking
		anim_aoa_end =		{SPR_PLAY, D, C, B, A, 2, "SPR2_ROLL"},		-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},				-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},				-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_PAIN"},				-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},				-- dies
		anim_revive =		{SPR_PLAY, A, 1, "SPR2_SPNG"},				-- gets revived
		anim_evoker =       {SPR_PLAY, A, 1, "SPR2_SPNG"},				-- using evoker.
	
		anim_stand_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},				-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_run_super = 	{SPR_PLAY, A, 2, "SPR2_SPNG"},				-- run
		
		supercolor_start = SKINCOLOR_SUPERGOLD1,

		-- VOICES
		-- Silent character go brrr

		vfx_summon = {},	-- Summoning Persona to use a Skill
        vfx_skill = {},		-- Used a Skill
        vfx_item = {},		-- Used an item
        vfx_hurt = {},		-- Sustained damage
        vfx_hurtx = {},		-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {},		-- Death
        vfx_heal = {},		-- Healed by teammate
        vfx_healself = {},	-- Healed self
        vfx_kill = {},		-- Killed an enemy
        vfx_1more = {},		-- Performed 1more
        vfx_crit = {},		-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {},	-- Ask to All-Out Attack
        vfx_aoado = {},		-- Performing All-Out Attack
        vfx_aoarelent = {},	-- Relenting from All-Out Attack
        vfx_miss = {},		-- Missed attack
        vfx_dodge = {},		-- Dodged enemy attack
        vfx_win = {},		-- Battle won
        vfx_levelup = {},	-- Level Up!

		-- HUD DEFINTIIONS
		icon = "ICO_LGEU",				-- head icon for character select
		hudbust = "LGEUBAR",			-- patch to draw on the stat hud
		hudaoa = "LGEUAOA",				-- patch for all out attack hud
		aoa_quote = "........!",	-- all out attack quote.
		hudcutin = "EUPH_A",			-- cut in frames prefix

		-- Tip to display on the character select.
		-- Give insight on their skill type and their strengths/weaknesses in battle!
		tip = "Learns mainly Psy & Ice magic with some \nbuffs. Being able to crit with it's Psy \nmagic, they sometimes have a \nbetter time attacking than supporting.",
}

// Eupha's Persona
personaList["euphorica"] = {
	-- GENERAL
	name = "Omoikane",
	arcana = ARCANA_HIEROPHANT,

	-- STATS (at level 10. so we can have some precision, y'see)
	sprite = SPR_PSNC,
	anim_idle =	{SPR_PSNC, A, B, C, B, 8},
	anim_atk = {SPR_PSNC, D, E, F, F, F, F, G, H, H, H, H, H, H, H, H, H, 2},
	startframe = 0,

	strength = 3,
	magic = 5,
	endurance = 7,
	luck = 12,
	agility = 9,
	weak = ATK_PIERCE|ATK_CURSE,
	resist = ATK_BLESS,
	repel = ATK_PSY,
	skills = {
		{"psyblast", 1}, {"dia", 5},
		{"patra", 7}, {"makakaja", 10}, {"media", 15},
		{"makanda", 20}, {"mapsi", 23}, 
		
		{"me patra", 30, "patra"}, {"diarama", 32, "dia"},	
		{"psystrike", 34, "psyblast"}, {"mamakakaja", 36, "makakaja"},
		{"mamakanda", 38, "makanda"},  {"mediarama", 42, "media"},
		{"mapsio", 45, "mapsi"}, 
		
		{"psysplosion", 49, "psystrike"}, {"auto-mamaka", 53},
		{"diarahan", 57, "diarama"},
		
		{"mapsiodyne", 68, "mapsio"}, {"mediarahan", 72, "mediarama"},
		{"psystruction", 78, "mapsiodyne"},
	},
}

personaList["euphorica_legacy"] = {
	-- GENERAL
	name = "Omoikane",
	arcana = ARCANA_HIEROPHANT,

	-- STATS (at level 10. so we can have some precision, y'see)
	sprite = SPR_PSNC,
	anim_idle =	{SPR_PSNC, A, B, C, B, 8},
	anim_atk = {SPR_PSNC, D, E, F, F, F, F, G, H, H, H, H, H, H, H, H, H, 2},
	startframe = 0,

	strength = 4,
	magic = 12,
	endurance = 6,
	luck = 6,
	agility = 9,
	weak = ATK_PIERCE|ATK_CURSE,
	resist = ATK_ICE,
	repel = ATK_PSY,
	skills = {
		{"psyblast", 1}, {"dia", 3},
		{"makakaja", 14}, {"bufu", 16}, 
		{"mapsi", 21},

		{"diarama", 23, "dia"}, {"psy break", 25}, 
		{"bufula", 29, "bufu"}, {"makarakarn", 31}, 
		{"psystrike", 36, "psyblast"}, {"mamakakaja", 40, "makakaja"},

		{"mapsio", 44, "mapsi"}, {"psysplosion", 46, "psystrike"},
		{"bufudyne", 48, "bufula"}, {"auto-mamaka", 60}, 
		{"diarahan", 65, "diarama"}, {"mapsiodyne", 69, "mapsio"},
		{"psystruction", 75, "mapsiodyne"},
	},
}